﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public static class DrawLineClass {

    public static void DrawLineHorizontal(this Texture2D tex, int x1, int x2, int y, Color col)
    {
        for (int i = x1; i <= x2; i++)
        {
            tex.SetPixel(i, y, col);
        }
    }

    public static void DrawLineVertical(this Texture2D tex, int x, int y1, int y2, Color col)
    {
        for (int i = y1; i <= y2; i++)
        {
            tex.SetPixel(x, i, col);
        }
    }

    public static void DrawLine(this Texture2D tex, Vector2 p1, Vector2 p2, Color col)
    {
        Vector2 t = p1;
        float frac = 1 / Mathf.Sqrt(Mathf.Pow(p2.x - p1.x, 2) + Mathf.Pow(p2.y - p1.y, 2));
        float ctr = 0;

        while ((int)t.x != (int)p2.x || (int)t.y != (int)p2.y)
        {
            t = Vector2.Lerp(p1, p2, ctr);
            ctr += frac;
            tex.SetPixel((int)t.x, (int)t.y, col);
        }
    }
}
