﻿using System.Collections;
using System.Collections.Generic;

namespace UPP
{

    public class Size
    {
        private float oldWidth;
        private float oldHeight;
        public float Width { get { return oldWidth; } set { SetWidth(value); } }
        public float Height { get { return oldHeight; } set { SetHeight(value); } }

        public delegate void SizeChangedHandler(float oldWidth, float oldHeight, float newWidth, float newHeight);
        public event SizeChangedHandler SizeChanged;

        private void SetWidth(float newVal)
        {
            //newVal = UnityEngine.Mathf.Max(newVal, 0);
            if (newVal != oldWidth)
            {
                float x = oldWidth;
                oldWidth = newVal;
                if (SizeChanged != null)
                    SizeChanged(x, oldHeight, newVal, oldHeight);
            }
        }

        private void SetHeight(float newVal)
        {
            //newVal = UnityEngine.Mathf.Max(newVal, 0);
            if (newVal != oldHeight)
            {
                float x = oldHeight;
                oldHeight = newVal;
                if (SizeChanged != null)
                    SizeChanged(oldWidth, x, oldWidth, newVal);
            }
        }

        public Size()
        {
            this.oldWidth = 100;
            this.oldHeight = 100;
        }

        public Size(float width, float height)
        {
            this.oldWidth = width;
            this.oldHeight = height;
        }

        public override string ToString()
        {
            return "W: " + this.Width.ToString("0.000") + " H: " + this.Height.ToString("0.000");
        }
    }

}